﻿Imports System

Namespace ServerREC
    Public Class cVaxArrayBuff

        Private m_aMainBuff As Byte()
        Private m_nTotalSize As Integer

        Private m_nWriteIndex As Integer
        Private m_nGrowSize As Integer

        Public Sub New()
            m_aMainBuff = Nothing
            m_nTotalSize = 0

            m_nWriteIndex = 0
            m_nGrowSize = 16000
        End Sub

        Protected Overrides Sub Finalize()
            ResetBuff()
            MyBase.Finalize()
        End Sub

        Private Sub AllocBuff()
            If m_aMainBuff IsNot Nothing Then Return

            m_aMainBuff = New Byte(m_nGrowSize - 1) {}
            m_nTotalSize = m_nGrowSize
        End Sub

        Private Sub AdjustBuff(nDataSize As Integer)
            If (m_nWriteIndex + nDataSize) <= m_nTotalSize Then Return

            Dim nTotalSize As Integer = m_nTotalSize

            While True
                nTotalSize += m_nGrowSize

                If (m_nWriteIndex + nDataSize) <= nTotalSize Then Exit While
            End While

            Dim aDataBuff As Byte() = New Byte(nTotalSize - 1) {}
            Buffer.BlockCopy(m_aMainBuff, 0, aDataBuff, 0, m_nWriteIndex)

            m_aMainBuff = aDataBuff
            m_nTotalSize = nTotalSize
        End Sub

        Public Sub ResetBuff()
            m_nWriteIndex = 0

            If m_aMainBuff IsNot Nothing Then
                m_aMainBuff = Nothing
            End If

            m_nTotalSize = 0
        End Sub

        Public Sub SetSizeGrow(nSize As Integer)
            m_nGrowSize = nSize
        End Sub

        Public Function GetDataBuff() As Byte()
            Return m_aMainBuff
        End Function

        Public Function GetSizeBuff() As Integer
            Return m_nWriteIndex
        End Function

        Public Sub WriteToBuff(aDataBuff As Byte(), nSizeBuff As Integer)
            AllocBuff()

            If nSizeBuff <= 0 Then Return

            AdjustBuff(nSizeBuff)

            Buffer.BlockCopy(aDataBuff, 0, m_aMainBuff, m_nWriteIndex, nSizeBuff)
            m_nWriteIndex += nSizeBuff
        End Sub

    End Class
End Namespace
