﻿Imports System
Imports System.Runtime.InteropServices
Imports VaxTeleServerRECLib

Public Class cVaxServerCOM

    Public Const SIP_DEFAULT_PORT As Integer = 6080

    Public Const VAX_PEER_TYPE_USER As Integer = 0
    Public Const VAX_PEER_TYPE_LINE As Integer = 1

    Public Const VAX_LINE_TYPE_UDP As Integer = 0
    Public Const VAX_LINE_TYPE_TCP As Integer = 1
    Public Const VAX_LINE_TYPE_TLS As Integer = 2

    '///////////////////////////////////////////////////////////

    Public Const VAX_WAVE_REC_TYPE_MONO_PCM As Integer = 0
    Public Const VAX_WAVE_REC_TYPE_STEREO_PCM As Integer = 1
    Public Const VAX_WAVE_REC_TYPE_MONO_G711U As Integer = 2
    Public Const VAX_WAVE_REC_TYPE_STEREO_G711U As Integer = 3
    Public Const VAX_WAVE_REC_TYPE_MONO_G711A As Integer = 4
    Public Const VAX_WAVE_REC_TYPE_STEREO_G711A As Integer = 5

    '///////////////////////////////////////////////////////////

    Public Const VAX_CODEC_GSM610 As Integer = 0
    Public Const VAX_CODEC_ILBC As Integer = 1
    Public Const VAX_CODEC_G711A As Integer = 2
    Public Const VAX_CODEC_G711U As Integer = 3
    Public Const VAX_CODEC_G729 As Integer = 4

    Public Const VAX_CODEC_TOTAL_COUNT As Integer = 5

    '///////////////////////////////////////////////////////////

    Public Const VAX_CUSTOM_HEADER_REQ_ID_INVITE As Integer = 0

    '///////////////////////////////////////////////////////////

    Public Const VAX_CLOSED_REASON_CODE_HANGUP As Integer = 0
    Public Const VAX_CLOSED_REASON_CODE_SESSION_LOST As Integer = 1
    Public Const VAX_CLOSED_REASON_CODE_MOVED As Integer = 2
    Public Const VAX_CLOSED_REASON_CODE_TRANSFERED As Integer = 3
    Public Const VAX_CLOSED_REASON_CODE_REJECTED As Integer = 4
    Public Const VAX_CLOSED_REASON_CODE_FAILED As Integer = 5
    Public Const VAX_CLOSED_REASON_CODE_CANCELLED As Integer = 6
    Public Const VAX_CLOSED_REASON_CODE_TIMEOUT As Integer = 7
    Public Const VAX_CLOSED_REASON_CODE_CLOSED As Integer = 8

    '///////////////////////////////////////////////////////////

    Public Const VAX_ACCESS_PCM_TYPE_ALL_NONE As Integer = -1
    Public Const VAX_ACCESS_PCM_TYPE_EVENT_NONE As Integer = 0
    Public Const VAX_ACCESS_PCM_TYPE_EVENT_MEDIA_ZERO As Integer = 1
    Public Const VAX_ACCESS_PCM_TYPE_EVENT_MEDIA_ONE As Integer = 2
    Public Const VAX_ACCESS_PCM_TYPE_PIPE_NONE As Integer = 3
    Public Const VAX_ACCESS_PCM_TYPE_PIPE_MEDIA_ZERO As Integer = 4
    Public Const VAX_ACCESS_PCM_TYPE_PIPE_MEDIA_ONE As Integer = 5

    '///////////////////////////////////////////////////////////

    Public Const VAX_MEDIA_DETECT_VAD_TYPE_ZERO As Integer = 0
    Public Const VAX_MEDIA_DETECT_VAD_TYPE_ONE As Integer = 1

    '///////////////////////////////////////////////////////////

    Private m_objVaxServerREC As VaxServerREC = New VaxServerREC()

    Public Sub New()

        AddHandler m_objVaxServerREC.OnUnRegisterUser, AddressOf OnUnRegisterUser
        AddHandler m_objVaxServerREC.OnRegisterUser, AddressOf OnRegisterUser

        AddHandler m_objVaxServerREC.OnRegisterUserFailed, AddressOf OnRegisterUserFailed
        AddHandler m_objVaxServerREC.OnRegisterUserSuccess, AddressOf OnRegisterUserSuccess

        AddHandler m_objVaxServerREC.OnLineRegisterTrying, AddressOf OnLineRegisterTrying
        AddHandler m_objVaxServerREC.OnLineRegisterFailed, AddressOf OnLineRegisterFailed
        AddHandler m_objVaxServerREC.OnLineRegisterSuccess, AddressOf OnLineRegisterSuccess

        AddHandler m_objVaxServerREC.OnLineUnRegisterTrying, AddressOf OnLineUnRegisterTrying
        AddHandler m_objVaxServerREC.OnLineUnRegisterFailed, AddressOf OnLineUnRegisterFailed
        AddHandler m_objVaxServerREC.OnLineUnRegisterSuccess, AddressOf OnLineUnRegisterSuccess

        AddHandler m_objVaxServerREC.OnIncomingCall, AddressOf OnIncomingCall
        AddHandler m_objVaxServerREC.OnCallSessionConnected, AddressOf OnCallSessionConnected
        AddHandler m_objVaxServerREC.OnCallSessionClosed, AddressOf OnCallSessionClosed

        AddHandler m_objVaxServerREC.OnCallSessionLost, AddressOf OnCallSessionLost
        AddHandler m_objVaxServerREC.OnCallSessionHangup, AddressOf OnCallSessionHangup
        AddHandler m_objVaxServerREC.OnCallSessionTimeout, AddressOf OnCallSessionTimeout
        AddHandler m_objVaxServerREC.OnCallSessionCancelled, AddressOf OnCallSessionCancelled

        AddHandler m_objVaxServerREC.OnOutgoingDiagnosticLog, AddressOf OnOutgoingDiagnosticLog
        AddHandler m_objVaxServerREC.OnIncomingDiagnosticLog, AddressOf OnIncomingDiagnosticLog

        AddHandler m_objVaxServerREC.OnVaxServerTick, AddressOf OnVaxServerTick

        AddHandler m_objVaxServerREC.OnCallSessionCreated, AddressOf OnCallSessionCreated
        AddHandler m_objVaxServerREC.OnCallSessionRecordedWaveREC, AddressOf OnCallSessionRecordedWaveREC
        
        AddHandler m_objVaxServerREC.OnVaxErrorLog, AddressOf OnVaxErrorLog
        AddHandler m_objVaxServerREC.OnCallSessionErrorLog, AddressOf OnCallSessionErrorLog

        AddHandler m_objVaxServerREC.OnCallSessionAccessAudioPCM, AddressOf OnCallSessionAccessAudioPCM

        AddHandler m_objVaxServerREC.OnAttackDetectedScanSIP, AddressOf OnAttackDetectedScanSIP
        AddHandler m_objVaxServerREC.OnAttackDetectedFloodSIP, AddressOf OnAttackDetectedFloodSIP
        AddHandler m_objVaxServerREC.OnAttackDetectedBruteForceSIP, AddressOf OnAttackDetectedBruteForceSIP

        AddHandler m_objVaxServerREC.OnCallSessionMediaDetectStartedVAD, AddressOf OnCallSessionMediaDetectStartedVAD
        AddHandler m_objVaxServerREC.OnCallSessionMediaDetectCompletedVAD, AddressOf OnCallSessionMediaDetectCompletedVAD
        AddHandler m_objVaxServerREC.OnCallSessionMediaDetectExpiredVAD, AddressOf OnCallSessionMediaDetectExpiredVAD

    End Sub

    Public Function GetVersionSDK() As String
        Return m_objVaxServerREC.GetVersionSDK()
    End Function

    Public Function GetVersionFile() As String
        Return m_objVaxServerREC.GetVersionFile()
    End Function

    Public Sub SetLicenseKey(ByVal sLicenseKey As String)
        m_objVaxServerREC.SetLicenseKey(sLicenseKey)
    End Sub

    Public Function Initialize(ByVal sDomainRealm As String) As Boolean
        Return m_objVaxServerREC.Initialize(sDomainRealm)
    End Function

    Public Sub UnInitialize()
        m_objVaxServerREC.UnInitialize()
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////////////

    Public Function CryptoMediaNONE(ByVal bForced As Boolean) As Boolean
        Return m_objVaxServerREC.CryptoMediaNONE(bForced)
    End Function

    Public Function CryptoMediaSDP(ByVal bForced As Boolean) As Boolean
        Return m_objVaxServerREC.CryptoMediaSDP(bForced)
    End Function

    '/////////////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////////////
    Public Function OpenNetworkUDP(ByVal sListenIP As String, ByVal nListenPort As Integer) As Boolean
        Return m_objVaxServerREC.OpenNetworkUDP(sListenIP, nListenPort)
    End Function

    Public Function OpenNetworkTCP(ByVal sListenIP As String, ByVal nListenPort As Integer) As Boolean
        Return m_objVaxServerREC.OpenNetworkTCP(sListenIP, nListenPort)
    End Function

    Public Function OpenNetworkTLS(ByVal sListenIP As String, ByVal nListenPort As Integer, ByVal sCertPEM As String) As Boolean
        Return m_objVaxServerREC.OpenNetworkTLS(sListenIP, nListenPort, sCertPEM)
    End Function

    Public Sub CloseNetworkUDP()
        m_objVaxServerREC.CloseNetworkUDP()
    End Sub

    Public Sub CloseNetworkTCP()
        m_objVaxServerREC.CloseNetworkTCP()
    End Sub

    Public Sub CloseNetworkTLS()
        m_objVaxServerREC.CloseNetworkTLS()
    End Sub

    Public Function SetListenPortRangeRTP(ByVal nListenStartPort As Integer, ByVal nListenEndPort As Integer) As Boolean
        Return m_objVaxServerREC.SetListenPortRangeRTP(nListenStartPort, nListenEndPort)
    End Function

    Public Function SetNetworkMediaRTP(ByVal sListenIP As String, ByVal nListenStartPort As Integer) As Boolean
        Return m_objVaxServerREC.SetNetworkMediaRTP(sListenIP, nListenStartPort)
    End Function

    Public Function AddUser(ByVal sUserName As String, ByVal sPassword As String, ByVal sAudioCodecList As String) As Boolean
        Return m_objVaxServerREC.AddUser(sUserName, sPassword, sAudioCodecList)
    End Function

    Public Sub RemoveUser(ByVal sUserName As String)
        m_objVaxServerREC.RemoveUser(sUserName)
    End Sub

    Public Function AcceptRegister(ByVal nRegId As Integer) As Boolean
        Return m_objVaxServerREC.AcceptRegister(nRegId)
    End Function

    Public Function RejectRegister(ByVal nRegId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String) As Boolean
        Return m_objVaxServerREC.RejectRegister(nRegId, nStatusCode, sReasonPhrase)
    End Function

    Public Function AttachRegister(ByVal nRegId As Integer, ByVal sUserName As String) As Boolean
        Return m_objVaxServerREC.AttachRegister(nRegId, sUserName)
    End Function

    Public Function AuthRegister(ByVal nRegId As Integer) As Boolean
        Return m_objVaxServerREC.AuthRegister(nRegId)
    End Function

    Public Function RegisterUserExpiry(ByVal nExpiry As Integer) As Boolean
        Return m_objVaxServerREC.RegisterUserExpiry(nExpiry)
    End Function

    Public Function AddLine(ByVal sLineName As String, ByVal nLineType As Integer, ByVal sDisplayName As String, ByVal sUserName As String, ByVal sAuthUser As String, ByVal sAuthPwd As String, ByVal sDomainRealm As String, ByVal sServerAddr As String, ByVal nServerPort As Integer, ByVal sAudioCodecList As String) As Boolean
        Return m_objVaxServerREC.AddLine(sLineName, nLineType, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sServerAddr, nServerPort, sAudioCodecList)
    End Function

    Public Sub RemoveLine(ByVal sLineName As String)
        m_objVaxServerREC.RemoveLine(sLineName)
    End Sub

    Public Function RegisterLine(ByVal sLineName As String, ByVal nExpire As Integer) As Boolean
        Return m_objVaxServerREC.RegisterLine(sLineName, nExpire)
    End Function

    Public Function UnRegisterLine(ByVal sLineName As String) As Boolean
        Return m_objVaxServerREC.UnRegisterLine(sLineName)
    End Function

    Public Function AcceptCallSession(ByVal nSessionId As Integer, ByVal nTimeout As Integer) As Boolean
        Return m_objVaxServerREC.AcceptCallSession(nSessionId, nTimeout)
    End Function

    Public Function RejectCallSession(ByVal nSessionId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String) As Boolean
        Return m_objVaxServerREC.RejectCallSession(nSessionId, nStatusCode, sReasonPhrase)
    End Function

    Public Function CloseCallSession(ByVal nSessionId As Integer) As Boolean
        Return m_objVaxServerREC.CloseCallSession(nSessionId)
    End Function

    Public Function RecordWaveSetCacheSize(ByVal nCacheSize As Integer) As Boolean
        Return m_objVaxServerREC.RecordWaveSetCacheSize(nCacheSize)
    End Function

    Public Function RecordWaveStartToCallSession(ByVal nSessionId As Integer, ByVal sFileName As String, ByVal nTypeREC As Integer) As Boolean
        Return m_objVaxServerREC.RecordWaveStartToCallSession(nSessionId, sFileName, nTypeREC)
    End Function

    Public Sub RecordWaveStopToCallSession(ByVal nSessionId As Integer)
        m_objVaxServerREC.RecordWaveStopToCallSession(nSessionId)
    End Sub

    Public Function RecordWavePauseToCallSession(ByVal nSessionId As Integer, ByVal bEnable As Boolean) As Boolean
        Return m_objVaxServerREC.RecordWavePauseToCallSession(nSessionId, bEnable)
    End Function

    Public Function AudioSessionLost(ByVal bEnable As Boolean, ByVal nTimeout As Integer) As Boolean
        Return m_objVaxServerREC.AudioSessionLost(bEnable, nTimeout)
    End Function

    Public Function VaxServerStartTick(ByVal nTickId As Integer, ByVal nElapse As Integer) As Boolean
        Return m_objVaxServerREC.VaxServerStartTick(nTickId, nElapse)
    End Function

    Public Function VaxServerStopTick(ByVal nTickId As Integer) As Boolean
        Return m_objVaxServerREC.VaxServerStopTick(nTickId)
    End Function

    Public Function SetUserAgentName(ByVal sName As String) As Boolean
        Return m_objVaxServerREC.SetUserAgentName(sName)
    End Function

    Public Function GetUserAgentName() As String
        Return m_objVaxServerREC.GetUserAgentName().ToString()
    End Function

    Public Function SetSessionNameSDP(ByVal sName As String) As Boolean
        Return m_objVaxServerREC.SetSessionNameSDP(sName)
    End Function

    Public Function GetSessionNameSDP() As String
        Return m_objVaxServerREC.GetSessionNameSDP().ToString()
    End Function

    Public Function GetVaxErrorCode() As Integer
        Return m_objVaxServerREC.GetVaxErrorCode()
    End Function

    Public Function DiagnosticLogSIP(ByVal bInbound As Boolean, ByVal bOutbound As Boolean) As Boolean
        Return m_objVaxServerREC.DiagnosticLogSIP(bInbound, bOutbound)
    End Function

    Public Function CallSessionSendStatusResponse(ByVal nSessionId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String, ByVal sContactURI As String) As Boolean
        Return m_objVaxServerREC.CallSessionSendStatusResponse(nSessionId, nStatusCode, sReasonPhrase, sContactURI)
    End Function

    Public Function AddCustomHeader(ByVal nReqId As Integer, ByVal sName As String, ByVal sValue As String) As Boolean
        Return m_objVaxServerREC.AddCustomHeader(nReqId, sName, sValue)
    End Function

    Public Function RemoveCustomHeader(ByVal nReqId As Integer, ByVal sName As String) As Boolean
        Return m_objVaxServerREC.RemoveCustomHeader(nReqId, sName)
    End Function

    Public Function RemoveCustomHeaderAll(ByVal nReqId As Integer) As Boolean
        Return m_objVaxServerREC.RemoveCustomHeaderAll(nReqId)
    End Function

    Public Function GetCallSessionTxCodec(ByVal nSessionId As Integer) As Integer
        Return m_objVaxServerREC.GetCallSessionTxCodec(nSessionId)
    End Function

    Public Function GetCallSessionRxCodec(ByVal nSessionId As Integer) As Integer
        Return m_objVaxServerREC.GetCallSessionRxCodec(nSessionId)
    End Function

    Public Function GetCallCount() As Integer
        Return m_objVaxServerREC.GetCallCount()
    End Function

    Public Function GetCallSessionHeaderCallId(ByVal nSessionId As Integer) As String
        Return m_objVaxServerREC.GetCallSessionHeaderCallId(nSessionId)
    End Function

    Public Function CallSessionMuteVoice(ByVal nSessionId As Integer, ByVal bListen As Boolean, ByVal bSpeak As Boolean) As Boolean
        Return m_objVaxServerREC.CallSessionMuteVoice(nSessionId, bListen, bSpeak)
    End Function

    Public Function AddNetworkRouteSIP(ByVal sAssignedIP As String, ByVal sRouterIP As String) As Boolean
        Return m_objVaxServerREC.AddNetworkRouteSIP(sAssignedIP, sRouterIP)
    End Function

    Public Function AddNetworkRouteRTP(ByVal sAssignedIP As String, ByVal sRouterIP As String) As Boolean
        Return m_objVaxServerREC.AddNetworkRouteRTP(sAssignedIP, sRouterIP)
    End Function

    Public Function AccessAudioPCM(ByVal nSessionId As Integer, ByVal sPipeName As String, ByVal nAccessType As Integer) As Boolean
        Return m_objVaxServerREC.AccessAudioPCM(nSessionId, sPipeName, nAccessType)
    End Function

    Public Function AttackDetectScanSIP(sDomainName As String) As Boolean
        Return m_objVaxServerREC.AttackDetectScanSIP(sDomainName)
    End Function

    Public Function AttackDetectFloodSIP(nReqRecvLimit As Integer) As Boolean
        Return m_objVaxServerREC.AttackDetectFloodSIP(nReqRecvLimit)
    End Function

    Public Function AttackDetectBruteForceSIP(nFailureCount As Integer, nFailureInterval As Integer) As Boolean
        Return m_objVaxServerREC.AttackDetectBruteForceSIP(nFailureCount, nFailureInterval)
    End Function

    Public Function DetectStartVAD(ByVal nSessionId As Integer, ByVal nAudioLevelVU As Integer, ByVal nSilenceLengthPCM As Integer, ByVal nSilenceCountPCM As Integer, ByVal nAnalysisLengthPCM As Integer, ByVal nExpiryLengthPCM As Integer, ByVal nProcessLengthPCM As Integer, ByVal nDetectType As Integer) As Boolean
        Return m_objVaxServerREC.DetectStartVAD(nSessionId, nAudioLevelVU, nSilenceLengthPCM, nSilenceCountPCM, nAnalysisLengthPCM, nExpiryLengthPCM, nProcessLengthPCM, nDetectType)
    End Function

    Public Sub DetectStopVAD(ByVal nSessionId As Integer)
        m_objVaxServerREC.DetectStopVAD(nSessionId)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////////////

    Protected Overridable Sub OnUnRegisterUser(ByVal sUserName As String)
    End Sub

    Protected Overridable Sub OnRegisterUser(ByVal sUserName As String, ByVal sDomain As String, ByVal sUserAgentName As String, ByVal sFromIP As String, ByVal nFromPort As Integer, ByVal nRegId As Integer)
    End Sub

    Protected Overridable Sub OnRegisterUserFailed(ByVal sUserName As String, ByVal sFromIP As String, ByVal nFromPort As Integer, ByVal nRegId As Integer)
    End Sub

    Protected Overridable Sub OnRegisterUserSuccess(ByVal sUserName As String, ByVal sFromIP As String, ByVal nFromPort As Integer, ByVal nRegId As Integer)
    End Sub

    Protected Overridable Sub OnLineRegisterTrying(ByVal sLineName As String)
    End Sub

    Protected Overridable Sub OnLineRegisterFailed(ByVal sLineName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Protected Overridable Sub OnLineRegisterSuccess(ByVal sLineName As String)
    End Sub

    Protected Overridable Sub OnLineUnRegisterTrying(ByVal sLineName As String)
    End Sub

    Protected Overridable Sub OnLineUnRegisterFailed(ByVal sLineName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Protected Overridable Sub OnLineUnRegisterSuccess(ByVal sLineName As String)
    End Sub

    Protected Overridable Sub OnIncomingCall(ByVal nSessionId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sCalleeName As String, ByVal sCalleeId As String, ByVal sDialNo As String, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sUserAgentName As String, ByVal sRecXML As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Protected Overridable Sub OnCallSessionConnected(ByVal nSessionId As Integer)
    End Sub

    Protected Overridable Sub OnCallSessionClosed(ByVal nSessionId As Integer, ByVal nReasonCode As Integer)
    End Sub

    Protected Overridable Sub OnCallSessionLost(ByVal nSessionId As Integer)
    End Sub

    Protected Overridable Sub OnCallSessionHangup(ByVal nSessionId As Integer)
    End Sub

    Protected Overridable Sub OnCallSessionTimeout(ByVal nSessionId As Integer)
    End Sub

    Protected Overridable Sub OnCallSessionCancelled(ByVal nSessionId As Integer)
    End Sub

    Protected Overridable Sub OnOutgoingDiagnosticLog(ByVal sMsgSIP As String, ByVal sToIP As String, ByVal nToPort As Integer)
    End Sub

    Protected Overridable Sub OnIncomingDiagnosticLog(ByVal sMsgSIP As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Protected Overridable Sub OnVaxServerTick(ByVal nTickId As Integer)
    End Sub

    Protected Overridable Sub OnCallSessionCreated(ByVal nSessionId As Integer, ByVal nReasonCode As Integer)
    End Sub

    Private Sub OnCallSessionRecordedWaveREC(ByVal nSessionId As Integer, ByVal lDataREC As Long, ByVal nSizeREC As Integer, ByVal nTypeREC As Integer)
        Dim aDataREC As Byte() = New Byte(nSizeREC - 1) {}
        Marshal.Copy(New IntPtr(lDataREC), aDataREC, 0, nSizeREC)
        OnCallSessionRecordedWaveREC(nSessionId, aDataREC, nSizeREC, nTypeREC)
    End Sub

    Protected Overridable Sub OnCallSessionRecordedWaveREC(ByVal nSessionId As Integer, ByVal aDataREC As Byte(), ByVal nSizeREC As Integer, ByVal nTypeREC As Integer)
    End Sub

    Private Sub OnCallSessionAccessAudioPCM(ByVal nSessionId As Integer, ByVal nAccessType As Integer, ByVal lDataPCM As Long, ByVal nSizePCM As Integer, ByVal nTypePCM As Integer)
        Dim aDataPCM As Byte() = New Byte(nSizePCM - 1) {}
        Marshal.Copy(New IntPtr(lDataPCM), aDataPCM, 0, nSizePCM)
        OnCallSessionAccessAudioPCM(nSessionId, nAccessType, aDataPCM, nSizePCM, nTypePCM)
    End Sub

    Protected Overridable Sub OnCallSessionAccessAudioPCM(ByVal nSessionId As Integer, ByVal nAccessType As Integer, ByVal aDataPCM As Byte(), ByVal nSizePCM As Integer, ByVal nTypePCM As Integer)
    End Sub

    '//////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////////////
    Protected Overridable Sub OnAttackDetectedScanSIP(sReqMethod As String, sAddrIP As String, nAddrPort As Integer, nAddrType As Integer)
    End Sub

    Protected Overridable Sub OnAttackDetectedFloodSIP(sAddrIP As String, nAddrPort As Integer, nAddrType As Integer)
    End Sub

    Protected Overridable Sub OnAttackDetectedBruteForceSIP(sReqMethod As String, nAuthFailureCount As Integer, sAddrIP As String, nAddrPort As Integer, nAddrType As Integer)
    End Sub

    '//////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////////////
    Protected Overridable Sub OnVaxErrorLog(ByVal sFuncName As String, ByVal nErrorCode As Integer, ByVal sErrorMsg As String)
    End Sub

    Protected Overridable Sub OnCallSessionErrorLog(ByVal nSessionId As Integer, ByVal nErrorCode As Integer, ByVal sErrorMsg As String)
    End Sub

    '//////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////////////
    Protected Overridable Sub OnCallSessionMediaDetectStartedVAD(ByVal nSessionId As Integer)
    End Sub

    Private Sub OnCallSessionMediaDetectCompletedVAD(ByVal nSessionId As Integer, ByVal lDataPCM As Long, ByVal nSizePCM As Integer, ByVal nTypePCM As Integer)
        Dim aDataPCM As Byte() = New Byte(nSizePCM - 1) {}
        Marshal.Copy(New IntPtr(lDataPCM), aDataPCM, 0, nSizePCM)
        OnCallSessionMediaDetectCompletedVAD(nSessionId, aDataPCM, nSizePCM, nTypePCM)
    End Sub

    Protected Overridable Sub OnCallSessionMediaDetectCompletedVAD(ByVal nSessionId As Integer, ByVal aDataPCM As Byte(), ByVal nSizePCM As Integer, ByVal nTypePCM As Integer)
    End Sub

    Protected Overridable Sub OnCallSessionMediaDetectExpiredVAD(ByVal nSessionId As Integer)
    End Sub

End Class
