﻿Imports System
Imports System.Collections

Namespace ServerREC

    Class cVaxLine

        Public Shared Sub OnLineRegisterTrying(ByVal sLineName As String)
            Dim sStatus As String = sLineName & " " & cVaxDefine.LINE_REG_TRYING
            cVaxServerREC.mVaxREC.GenStatusLog(sStatus)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub OnLineRegisterFailed(ByVal sLineName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
            Dim sStatus As String = sLineName & " Register Failed: " & sReasonPhrase
            cVaxServerREC.mVaxREC.GenStatusLog(sStatus)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub OnLineRegisterSuccess(ByVal sLineName As String)
            Dim sStatus As String = sLineName & " " & cVaxDefine.LINE_REG_SUCCESS
            cVaxServerREC.mVaxREC.GenStatusLog(sStatus)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Function AddLine(ByVal sLineName As String, ByVal nLineType As Integer, ByVal sAuthUser As String, ByVal sAuthPwd As String, ByVal sServerAddr As String, ByVal nServerPort As Integer, ByVal sAudioCodecList As String, ByVal bRegister As Boolean) As Boolean

            If cVaxServerREC.mVaxREC.IsInitialized() = False OrElse (sLineName.Length = 0) Then
                Return False
            End If

            RemoveLine(sLineName)

            If Not cVaxServerREC.mVaxREC.AddLine(sLineName, nLineType, "", "", sAuthUser, sAuthPwd, "", sServerAddr, nServerPort, sAudioCodecList) Then
                Return False
            End If

            If bRegister Then
                cVaxServerREC.mVaxREC.RegisterLine(sLineName, 1800)
            End If

            cStoreLine.AddLine(sLineName, nLineType, sAuthUser, sAuthPwd, sServerAddr, nServerPort, sAudioCodecList, bRegister)

            Return True

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub RemoveLine(ByVal sLineName As String)

            If cVaxServerREC.mVaxREC.IsInitialized() = False OrElse (sLineName.Length = 0) Then Return

            cVaxServerREC.mVaxREC.RemoveLine(sLineName)
            cStoreLine.RemoveLine(sLineName)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub LoadLine()

            If Not cVaxServerREC.mVaxREC.IsInitialized() Then
                Return
            End If


            Dim objListLines As ArrayList = New ArrayList()
            cStoreLine.GetLineNameAll(objListLines)

            If objListLines.Count = 0 Then Return

            Dim sAuthUser As String = "", sAuthPwd As String = "", sServerAddr As String = "", sAudioCodecList As String = ""
            Dim bRegister As Boolean = False
            Dim nLineType As Integer = cVaxServerCOM.VAX_LINE_TYPE_UDP, nServerPort As Integer = cVaxServerCOM.SIP_DEFAULT_PORT

            For Each sLineName As String In objListLines
                cStoreLine.GetLine(sLineName, nLineType, sAuthUser, sAuthPwd, sServerAddr, nServerPort, sAudioCodecList, bRegister)
                AddLine(sLineName, nLineType, sAuthUser, sAuthPwd, sServerAddr, nServerPort, sAudioCodecList, bRegister)
            Next

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

    End Class

End Namespace
