﻿Imports System
Imports System.Collections

Namespace ServerREC

    Public Class cVaxServerREC : Inherits cVaxServerCOM

        Public m_objStatusLogDlg As StatusLogForm = Nothing
        Public Shared mVaxREC As cVaxServerREC = Nothing

        Private m_bInitialized As Boolean = False
        Private m_objSessionList As cVaxCallSessionList = Nothing
        Dim m_sRecordingFolder As String = ""

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Sub New()
            mVaxREC = Me
            ResetAll()
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Private Sub ResetAll()

            m_objSessionList = New cVaxCallSessionList()
            cVaxUser.ResetAll()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        Public Function StartServer(ByVal nListenPort As Integer) As Boolean

            StopServer()

            MyBase.SetLicenseKey("TRIAL-LICENSE-KEY")

            If Not MyBase.Initialize("") Then Return False

            If Not MyBase.OpenNetworkUDP("", nListenPort) Then
                UnInitialize()
                Return False
            End If

            If Not MyBase.OpenNetworkTCP("", nListenPort) Then
                UnInitialize()
                Return False
            End If

            If Not MyBase.OpenNetworkTLS("", nListenPort + 1, "") Then
                UnInitialize()
                Return False
            End If

            ' MyBase.AttackDetectScanSIP("demo.vaxvoip.com")
            ' MyBase.AttackDetectFloodSIP(1000)
            ' MyBase.AttackDetectBruteForceSIP(10, 2)

            MyBase.SetListenPortRangeRTP(20000, 30000)
            MyBase.AudioSessionLost(True, 30) 'Enable voice session lost for 30 seconds.

            MyBase.AddLine("AnonymousUDP", cVaxServerCOM.VAX_LINE_TYPE_UDP, "", "", "", "", "", "255.255.255.255", -1, "")
            MyBase.AddLine("AnonymousTCP", cVaxServerCOM.VAX_LINE_TYPE_TCP, "", "", "", "", "", "255.255.255.255", -1, "")
            MyBase.AddLine("AnonymousTLS", cVaxServerCOM.VAX_LINE_TYPE_TLS, "", "", "", "", "", "255.255.255.255", -1, "")

            m_bInitialized = True
            OnInitialize()

            Return True

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Sub StopServer()

            m_bInitialized = False

            MyBase.UnInitialize()
            ResetAll()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Function IsInitialized() As Boolean
            Return m_bInitialized
        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Overloads Function AcceptCallSession(ByVal nSessionId As Integer) As Boolean
            Return MyBase.AcceptCallSession(nSessionId, 30)
        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Sub SetRecordingFolder(ByVal sRecPath As String)

            m_sRecordingFolder = sRecPath

        End Sub

        Public Function GetRecordingFolder() As String

            Return m_sRecordingFolder

        End Function

        Public Overloads Function RecordWaveStartToCallSession(ByVal nSessionId As Integer, ByVal sFileName As String) As Boolean

            Return MyBase.RecordWaveStartToCallSession(nSessionId, sFileName, cVaxServerCOM.VAX_WAVE_REC_TYPE_STEREO_PCM)

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Protected Overrides Sub OnCallSessionCreated(nSessionId As Integer, nReasonCode As Integer)

            m_objSessionList.AddSession(nSessionId)

        End Sub

        Protected Overrides Sub OnCallSessionClosed(nSessionId As Integer, nReasonCode As Integer)

            Dim objCallSession As cVaxCallSession = m_objSessionList.GetSession(nSessionId)

            If objCallSession IsNot Nothing Then
                objCallSession.OnCallSessionClosed(nSessionId, nReasonCode)
            End If

            m_objSessionList.RemoveSession(nSessionId)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Protected Overrides Sub OnCallSessionAccessAudioPCM(nSessionId As Integer, nAccessType As Integer, aDataPCM As Byte(), nSizePCM As Integer, nTypePCM As Integer)

            Dim objCallSession As cVaxCallSession = m_objSessionList.GetSession(nSessionId)
            If objCallSession Is Nothing Then Return

            objCallSession.OnCallSessionAccessAudioPCM(nSessionId, nAccessType, aDataPCM, nSizePCM)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Protected Overrides Sub OnIncomingCall(ByVal nSessionId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sCalleeName As String, ByVal sCalleeId As String, ByVal sDialNo As String, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sUserAgentName As String, ByVal sRecXML As String, ByVal sFromIP As String, ByVal nFromPort As Integer)

            Dim objCallSession As cVaxCallSession = m_objSessionList.GetSession(nSessionId)
            If objCallSession Is Nothing Then Return

            objCallSession.OnIncomingCall(nSessionId, sCallerName, sCallerId, sCalleeName, sCalleeId, sDialNo, nFromPeerType, sFromPeerName, sUserAgentName, sRecXML, sFromIP, nFromPort)

        End Sub

        Protected Overrides Sub OnCallSessionConnected(ByVal nSessionId As Integer)

            Dim objCallSession As cVaxCallSession = m_objSessionList.GetSession(nSessionId)
            If objCallSession Is Nothing Then Return

            objCallSession.OnCallSessionConnected(nSessionId)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Protected Overrides Sub OnLineRegisterTrying(ByVal sLineName As String)
            cVaxLine.OnLineRegisterTrying(sLineName)
        End Sub

        Protected Overrides Sub OnLineRegisterFailed(ByVal sLineName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
            cVaxLine.OnLineRegisterFailed(sLineName, nStatusCode, sReasonPhrase)
        End Sub

        Protected Overrides Sub OnLineRegisterSuccess(ByVal sLineName As String)
            cVaxLine.OnLineRegisterSuccess(sLineName)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Protected Overrides Sub OnRegisterUser(ByVal sUserLogin As String, ByVal sDomain As String, ByVal sUserAgentName As String, ByVal sFromIP As String, ByVal nFromPort As Integer, ByVal nRegId As Integer)
            cVaxUser.OnRegisterUser(sUserLogin, sDomain, sUserAgentName, sFromIP, nFromPort, nRegId)
        End Sub

        Protected Overrides Sub OnRegisterUserSuccess(ByVal sUserLogin As String, ByVal sFromIP As String, ByVal nFromPort As Integer, ByVal nRegId As Integer)
            cVaxUser.OnRegisterUserSuccess(sUserLogin, sFromIP, nFromPort, nRegId)
        End Sub

        Protected Overrides Sub OnRegisterUserFailed(ByVal sUserLogin As String, ByVal sFromIP As String, ByVal nFromPort As Integer, ByVal nRegId As Integer)
            cVaxUser.OnRegisterUserFailed(sUserLogin, sFromIP, nFromPort, nRegId)
        End Sub

        Protected Overrides Sub OnUnRegisterUser(ByVal sUserLogin As String)
            cVaxUser.OnUnRegisterUser(sUserLogin)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        Protected Overrides Sub OnCallSessionMediaDetectStartedVAD(ByVal nSessionId As Integer)

            Dim objCallSession As cVaxCallSession = m_objSessionList.GetSession(nSessionId)
            If objCallSession Is Nothing Then Return

            objCallSession.OnCallSessionMediaDetectStartedVAD(nSessionId)

        End Sub

        Protected Overrides Sub OnCallSessionMediaDetectCompletedVAD(ByVal nSessionId As Integer, ByVal aDataPCM As Byte(), ByVal nSizePCM As Integer, ByVal nTypePCM As Integer)

            Dim objCallSession As cVaxCallSession = m_objSessionList.GetSession(nSessionId)
            If objCallSession Is Nothing Then Return

            objCallSession.OnCallSessionMediaDetectCompletedVAD(nSessionId, aDataPCM, nSizePCM, nTypePCM)

        End Sub

        Protected Overrides Sub OnCallSessionMediaDetectExpiredVAD(ByVal nSessionId As Integer)

            Dim objCallSession As cVaxCallSession = m_objSessionList.GetSession(nSessionId)
            If objCallSession Is Nothing Then Return

            objCallSession.OnCallSessionMediaDetectExpiredVAD(nSessionId)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Sub GenStatusLog(ByVal sStatus As String)
            OnStatusLog(sStatus)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Protected Overrides Sub OnVaxErrorLog(ByVal sFuncName As String, ByVal nErrorCode As Integer, ByVal sErrorMsg As String)
            Dim sMsg As String = "[Method: " & sFuncName & "] [Error Msg: " & sErrorMsg & "] [Code: " & nErrorCode.ToString() & "]"
            OnStatusLog(sMsg)
        End Sub

        Protected Overrides Sub OnCallSessionErrorLog(ByVal nSessionId As Integer, ByVal nErrorCode As Integer, ByVal sErrorMsg As String)
            Dim sMsg As String = "[Session: " & nSessionId.ToString() & "] [Error Msg: " & sErrorMsg & "] [Code: " & nErrorCode.ToString() & "]"
            OnStatusLog(sMsg)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Private Sub OnInitialize()

            If Not cVaxSettingDefault.LoadUserDefault() Then
                cVaxUser.LoadUser()
            End If

            If Not cVaxSettingDefault.LoadLineDefault() Then
                cVaxLine.LoadLine()
            End If

        End Sub

        Private Sub OnStatusLog(ByVal sMsg As String)
            m_objStatusLogDlg.OnStatusLog(sMsg)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

    End Class

End Namespace
